/* Title:       JavaPhotoLab
 * Date:        12/08/98 - 03/11/02
 * Version:     1.31
 * Authors:     A. Brochard             P. Rolland Balzon
 * Email:       abrochard@ices.fr       prolland@free.fr
 */

import java.applet.Applet;
import java.awt.Color;
import java.awt.Event;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.net.URL;

public class JavaPhotoLab extends Applet
{
    Image[] img = new Image[20];
    ImageProcessing ip;

    int[] nom = { 40, 99, 41, 32, 49, 57, 57, 56, 45, 50, 48, 48, 50, 32,
		  65, 46, 32, 66, 114, 111, 99, 104, 97, 114, 100,
		  32, 45, 32,
		  80, 46, 32, 82, 111, 108, 108, 97, 110, 100, 32, 66, 97, 108, 122, 111, 110};

    int debut = 1;
    int nbvalues = 1;
    int mode;
    int w;
    int h;
    int ww;
    int hh;
    int currentimage = -1;
    int nbimage = -1;
    int xi;
    int yi;
    int i;
    int j;
    double minvalue1;
    double minvalue2;
    boolean fftmake;
    int condition1;
    int condition2;
    String filename = "Begin.jpg";
    String txtval1;
    String txtval2;
    Color cl1 = new Color(88, 128, 152);
    Color cl2 = ((JavaPhotoLab) this).cl1;
    int currentchoice;
    int currentmenu = 50;
    URL url;
    String urltxt = "http://prolland.free.fr/images/vacance.jpg";
    double value1 = 50.0;
    double value2 = 50.0;
    double maxvalue1 = 100.0;
    double maxvalue2 = 100.0;
    int numimages = 15;
    int[] numchoix
	= { ((JavaPhotoLab) this).numimages + 3, 10, 10, 7, 10, 7, 13, 3 };
    int categories = 8;
    int[] placeimg = new int[20];
    String[] filesimages
	= { "Hubble.jpg", "Toucan.jpg", "Hibiscus.jpg", "Hibisblr.jpg",
	    "Hibismot.jpg", "Hollynrm.jpg", "Hollyblr.jpg", "Hollymot.jpg",
	    "Holly64.jpg", "Text.jpg", "Textblr.jpg", "Ibd.jpg", "Stars.jpg",
	    "Starsblr.jpg", "1998.jpg" };
    String[][] nomsfiltres
	= { { "Clear Desktop", "Load URL", "Create Window (Snapshot)",
	      "Hubble Space Telescope", "Toucan", "Hibiscus (FFT)",
	      "Hibiscus blurred (FFT)", "Hibiscus moved (FFT)",
	      "Hollywood (FFT)", "Hollywood blurred (FFT)",
	      "Hollywood moved (FFT)", "Hollywood 64*64 (FFT)", "Text (FFT)",
	      "Text blurred (FFT)", "IBD Text blurred", "Star Field",
	      "Star Field blurred", "1998" },
	    { "Photoshop-like Effect", "Text deblurred", "B&W Photo deblurred",
	      "B&W Photo motion removal", "RGB Photo deblurred",
	      "RGB Photo motion removal", "Text deconvolved (5 it.)",
	      "Stars separation (17 it.)", "4x Zoom Ideal Interpolation",
	      "Lucy Restoration (200 it.)" },
	    { "Invert Colors", "Convert to Grayscale", "Brightness Filter",
	      "Contrast Filter", "Contrast Stretching", "Posterization",
	      "Tresholding", "Pseudo-Colors (B&W)", "Histogram Eq. (B&W)",
	      "Histogram" },
	    { "4x Zoom with Zeros fill", "Linear Interpolation",
	      "Bilinear Interpolation", "Enlarge to n*n FFT",
	      "Reduce to Original Image", "256*256 Center",
	      "256*256 Decenter" },
	    { "Gaussian Blur", "Sharpen", "LowPass Filter", "Median Filter",
	      "Kuwahara Filter", "Morph. Dilation", "Morph. Erosion",
	      "Morph. Opening (2 pass)", "Morph. Closing (2 pass)",
	      "Morph. Smoothing (4 pass)", "Add Gaussian Noise" },
	    { "Sobel", "Prewitt", "Roberts", "Laplacian",
	      "Morphological Gradient", "Morphological Laplacian", "Kirsh" },
	    { "Fast Fourier Transform", "Invert FFT", "LowPass Filter",
	      "HighPass Filter", "ButterWorth Low Filter",
	      "ButterWorth High Filter", "Gaussian PSF", "Motion PSF",
	      "Wiener Filt. (Gaussian PSF)", "Wiener Filt. (Motion PSF)",
	      "Blind Deconv. (B&W)", "Jpeg Codec (B&W only)",
	      "Richardson-Lucy" },
	    { "Metallic (FFT)", "Fusain", "Cartoon Effect" } };
    String[] categ
	= { "Desktop & Images...", "Demos...", "Histogram Operations...",
	    "Image Size", "Spatial Filters...", "Edge Detection...",
	    "FFT & Frequency Filters...", "Artistic Effects..." };
    
    public void Loadimg(String filename, boolean isurl) {
	((JavaPhotoLab) this).currentimage++;
	((JavaPhotoLab) this).nbimage++;
	this.showStatus("Caching Image - Please Wait");
	MediaTracker tracker = new MediaTracker(this);
	if (!isurl)
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= this.getImage(this.getDocumentBase(), filename);
	else {
	    try {
		((JavaPhotoLab) this).url = new URL(filename);
	    } catch (Exception exception) {
		this.showStatus("Error: " + exception.toString());
	    }
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= this.getImage(((JavaPhotoLab) this).url);
	}
	tracker.addImage((((JavaPhotoLab) this).img
			  [((JavaPhotoLab) this).currentimage]),
			 0);
	try {
	    tracker.waitForID(0);
	} catch (InterruptedException ex) {
	    this.showStatus("Error: " + ex.toString());
	}
	if (((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		.getHeight(this)
	    == -1) {
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= this.getImage(this.getDocumentBase(), "notfound.jpg");
	    tracker.addImage((((JavaPhotoLab) this).img
			      [((JavaPhotoLab) this).currentimage]),
			     0);
	    try {
		tracker.waitForID(0);
	    } catch (InterruptedException ex) {
		this.showStatus("Error: " + ex.toString());
	    }
	}
	this.showStatus("Done.");
	drawimage(((JavaPhotoLab) this).currentimage);
    }
    
    public void Addimg(Image image) {
	((JavaPhotoLab) this).currentimage = ((JavaPhotoLab) this).nbimage;
	((JavaPhotoLab) this).currentimage++;
	((JavaPhotoLab) this).nbimage++;
	((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage] = image;
	drawimage(((JavaPhotoLab) this).currentimage);
    }
    
    public void valueerase(Graphics g) {
	g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(0, 425, 750, 25);
    }
    
    public void drawimage(int rang) {
	Graphics g = this.getGraphics();
	g.setFont(new Font("Times", 0, 11));
	((JavaPhotoLab) this).w
	    = ((JavaPhotoLab) this).img[rang].getWidth(this);
	((JavaPhotoLab) this).h
	    = ((JavaPhotoLab) this).img[rang].getHeight(this);
	((JavaPhotoLab) this).xi = 10 + rang * 15;
	((JavaPhotoLab) this).yi = 10 + rang * 15;
	if (((JavaPhotoLab) this).placeimg[rang] == 1)
	    ((JavaPhotoLab) this).xi = 590 - ((JavaPhotoLab) this).w;
	g.setColor(Color.black);
	g.fillRect(((JavaPhotoLab) this).xi, ((JavaPhotoLab) this).yi,
		   ((JavaPhotoLab) this).w + 2, ((JavaPhotoLab) this).h + 21);
	g.setColor(Color.white);
	g.drawLine(((JavaPhotoLab) this).xi, ((JavaPhotoLab) this).yi,
		   ((JavaPhotoLab) this).xi + ((JavaPhotoLab) this).w + 1,
		   ((JavaPhotoLab) this).yi);
	g.drawLine(((JavaPhotoLab) this).xi, ((JavaPhotoLab) this).yi,
		   ((JavaPhotoLab) this).xi,
		   ((JavaPhotoLab) this).yi + ((JavaPhotoLab) this).h + 20);
	g.drawImage(((JavaPhotoLab) this).img[rang],
		    ((JavaPhotoLab) this).xi + 1,
		    ((JavaPhotoLab) this).yi + 20, this);
	g.setColor(Color.yellow);
	if (((JavaPhotoLab) this).w > 100)
	    g.drawString(("Img" + (rang + 1) + "  " + ((JavaPhotoLab) this).w
			  + "*" + ((JavaPhotoLab) this).h),
			 ((JavaPhotoLab) this).xi + 11,
			 ((JavaPhotoLab) this).yi + 14);
	else
	    g.drawString("Img" + (rang + 1), ((JavaPhotoLab) this).xi + 11,
			 ((JavaPhotoLab) this).yi + 14);
	g.setColor(Color.red);
	g.fillRect(((JavaPhotoLab) this).xi + 4, ((JavaPhotoLab) this).yi + 9,
		   4, 4);
    }
    
    public void Launch() {
	int process = (((JavaPhotoLab) this).currentchoice * 100
		       + ((JavaPhotoLab) this).currentmenu);
	if (process >= 3 && process < 3 + ((JavaPhotoLab) this).numimages) {
	    ((JavaPhotoLab) this).currentimage = ((JavaPhotoLab) this).nbimage;
	    ((JavaPhotoLab) this).filename
		= ((JavaPhotoLab) this).filesimages[process - 3];
	    Loadimg(((JavaPhotoLab) this).filename, false);
	}
	switch (process) {
	case 0:
	    ClearDesktop();
	    break;
	case 1: {
	    java.awt.Frame f
		= new EnterURL(this, ((JavaPhotoLab) this).urltxt);
	    f.setTitle("Enter Image URL");
	    f.resize(550, 100);
	    f.show();
	    break;
	}
	case 2: {
	    java.awt.Frame f
		= new FrameImage(((JavaPhotoLab) this).img
				 [((JavaPhotoLab) this).currentimage]);
	    f.setTitle("Make Snapshot");
	    f.resize(((JavaPhotoLab) this).w + 6,
		     ((JavaPhotoLab) this).h + 24);
	    f.show();
	    break;
	}
	case 100:
	    ClearDesktop();
	    Loadimg("Hibiscus.jpg", false);
	    ((JavaPhotoLab) this).img[18]
		= ((JavaPhotoLab) this).ip.Cartoon(((JavaPhotoLab) this).img
						   [(((JavaPhotoLab) this)
						     .currentimage)]);
	    ((JavaPhotoLab) this).placeimg[1] = 1;
	    Addimg(((JavaPhotoLab) this).ip
		       .Cartoon(((JavaPhotoLab) this).img[18]));
	    ((JavaPhotoLab) this).placeimg[1] = 0;
	    break;
	case 101:
	    ClearDesktop();
	    Loadimg("Textblr.jpg", false);
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.InvertColors(((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]));
	    Addimg(((JavaPhotoLab) this).ip.ContrastStretching
		   (((JavaPhotoLab) this).img
		    [((JavaPhotoLab) this).currentimage]));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.GaussianWiener
		   ((((JavaPhotoLab) this).img
		     [((JavaPhotoLab) this).currentimage]),
		    12.0, 3.0));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    ((JavaPhotoLab) this).placeimg[6] = 1;
	    Addimg(((JavaPhotoLab) this).ip.InvertColors(((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[6] = 0;
	    break;
	case 102:
	    ClearDesktop();
	    Loadimg("Hollyblr.jpg", false);
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.GaussianWiener
		   ((((JavaPhotoLab) this).img
		     [((JavaPhotoLab) this).currentimage]),
		    15.0, 3.0));
	    ((JavaPhotoLab) this).placeimg[3] = 1;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[3] = 0;
	    break;
	case 103:
	    ClearDesktop();
	    Loadimg("Hollymot.jpg", false);
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.MotionWiener((((JavaPhotoLab) this)
							  .img
							  [(((JavaPhotoLab)
							     this)
							    .currentimage)]),
							 30.0, 3.0));
	    ((JavaPhotoLab) this).placeimg[3] = 1;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[3] = 0;
	    break;
	case 104:
	    ClearDesktop();
	    Loadimg("Hibisblr.jpg", false);
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.GaussianWiener
		   ((((JavaPhotoLab) this).img
		     [((JavaPhotoLab) this).currentimage]),
		    21.0, 3.0));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.LowPassLinear(((JavaPhotoLab) this)
							  .img
							  [(((JavaPhotoLab)
							     this)
							    .currentimage)]));
	    ((JavaPhotoLab) this).placeimg[5] = 1;
	    Addimg(((JavaPhotoLab) this).ip.ContrastStretching
		   (((JavaPhotoLab) this).img
		    [((JavaPhotoLab) this).currentimage]));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[5] = 0;
	    break;
	case 105:
	    ClearDesktop();
	    Loadimg("Hibismot.jpg", false);
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.MotionWiener((((JavaPhotoLab) this)
							  .img
							  [(((JavaPhotoLab)
							     this)
							    .currentimage)]),
							 30.0, 2.0));
	    ((JavaPhotoLab) this).placeimg[3] = 1;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[3] = 0;
	    break;
	case 106:
	    ClearDesktop();
	    Loadimg("Ibd.jpg", false);
	    ((JavaPhotoLab) this).placeimg[5] = 1;
	    Addimg(((JavaPhotoLab) this).ip.Padding((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    128.0));
	    Addimg(((JavaPhotoLab) this).ip.IBD((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						5.0, 7.0));
	    Addimg(((JavaPhotoLab) this).ip.DePadding((((JavaPhotoLab) this)
						       .img
						       [(((JavaPhotoLab) this)
							 .currentimage)]),
						      110, 40));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[5] = 0;
	    break;
	case 107:
	    ClearDesktop();
	    Loadimg("Starsblr.jpg", false);
	    ((JavaPhotoLab) this).placeimg[12] = 1;
	    Addimg(((JavaPhotoLab) this).ip.PseudoColors(((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]));
	    Addimg(((JavaPhotoLab) this).ip.IBD(((JavaPhotoLab) this).img[0],
						17.0, 21.0));
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.LowPass((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    16.2));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.PseudoColors(((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]));
	    drawimage(1);
	    ((JavaPhotoLab) this).placeimg[12] = 0;
	    break;
	case 108:
	    ClearDesktop();
	    Loadimg("Holly64.jpg", false);
	    ((JavaPhotoLab) this).placeimg[4] = 1;
	    Addimg(((JavaPhotoLab) this).ip.Zoom4(((JavaPhotoLab) this).img
						  [(((JavaPhotoLab) this)
						    .currentimage)]));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.LowPass((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    32.0));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 1, true, ""));
	    drawimage(0);
	    ((JavaPhotoLab) this).placeimg[4] = 0;
	    break;
	case 109:
	    ClearDesktop();
	    Loadimg("1998.jpg", false);
	    ((JavaPhotoLab) this).placeimg[9] = 1;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						1, 0, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.GaussianBlur((((JavaPhotoLab) this)
							  .img
							  [(((JavaPhotoLab)
							     this)
							    .currentimage)]),
							 3.0));
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 1, true, ""));
	    Addimg(((JavaPhotoLab) this).ip.RL((((JavaPhotoLab) this).img
						[(((JavaPhotoLab) this)
						  .currentimage)]),
					       200.0, 3.0));
	    drawimage(3);
	    ((JavaPhotoLab) this).placeimg[9] = 0;
	    break;
	case 200:
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= ((JavaPhotoLab) this).ip.InvertColors(((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]);
	    drawimage(((JavaPhotoLab) this).currentimage);
	    break;
	case 201:
	    Addimg(((JavaPhotoLab) this).ip.GrayScale(((JavaPhotoLab) this).img
						      [(((JavaPhotoLab) this)
							.currentimage)]));
	    break;
	case 202:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Percentage:", 0.0, 50.0, 100.0, 0, "", 0.0,
			    0.5, 2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Brightness
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			(int) (((JavaPhotoLab) this).value1 * 2.56 - 128.0)));
	    break;
	case 203:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Percentage:", 0.0, 50.0, 100.0, 0, "", 0.0,
			    0.5, 2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Contrast
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			(int) (((JavaPhotoLab) this).value1 * 2.56 - 128.0)));
	    break;
	case 204:
	    Addimg(((JavaPhotoLab) this).ip.ContrastStretching
		   (((JavaPhotoLab) this).img
		    [((JavaPhotoLab) this).currentimage]));
	    break;
	case 205:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Levels:", 2.0, 8.0, 128.0, 1, "", 0.0, 0.5,
			    2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Posterize
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			((JavaPhotoLab) this).value1));
	    break;
	case 206:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Level:", 0.0, 128.0, 256.0, 1, "", 0.0, 0.5,
			    2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Treshold
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			((JavaPhotoLab) this).value1));
	    break;
	case 207:
	    Addimg(((JavaPhotoLab) this).ip.PseudoColors(((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]));
	    break;
	case 208:
	    Addimg(((JavaPhotoLab) this).ip.HistoEq(((JavaPhotoLab) this).img
						    [(((JavaPhotoLab) this)
						      .currentimage)]));
	    break;
	case 209:
	    ((JavaPhotoLab) this).ip.Histogram(((JavaPhotoLab) this).img
					       [(((JavaPhotoLab) this)
						 .currentimage)]);
	    break;
	case 300:
	    Addimg(((JavaPhotoLab) this).ip.Zoom4(((JavaPhotoLab) this).img
						  [(((JavaPhotoLab) this)
						    .currentimage)]));
	    break;
	case 301:
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= (((JavaPhotoLab) this).ip.LinearInterpolation
		   (((JavaPhotoLab) this).img
		    [((JavaPhotoLab) this).currentimage]));
	    drawimage(((JavaPhotoLab) this).currentimage);
	    break;
	case 302:
	    ((JavaPhotoLab) this).img[((JavaPhotoLab) this).currentimage]
		= (((JavaPhotoLab) this).ip.BiLinearInterpolation
		   (((JavaPhotoLab) this).img
		    [((JavaPhotoLab) this).currentimage]));
	    drawimage(((JavaPhotoLab) this).currentimage);
	    break;
	case 303:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "n=", 32.0, 128.0, 256.0, 1, "", 0.0, 0.5, 2.0,
			    1);
	    else
		Addimg(((JavaPhotoLab) this).ip.Padding
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			((JavaPhotoLab) this).value1));
	    break;
	case 304:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(2, "w=", 32.0, 128.0, 256.0, 1, "h=", 32.0, 128.0,
			    256.0, 1);
	    else
		Addimg(((JavaPhotoLab) this).ip.DePadding
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			(int) ((JavaPhotoLab) this).value1,
			(int) ((JavaPhotoLab) this).value2));
	    break;
	case 305:
	    if (((JavaPhotoLab) this).w <= 256
		&& ((JavaPhotoLab) this).h <= 256)
		Addimg(((JavaPhotoLab) this).ip.Center(((JavaPhotoLab) this)
						       .img
						       [(((JavaPhotoLab) this)
							 .currentimage)]));
	    break;
	case 306:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(2, "w=", 32.0, 128.0, 256.0, 1, "h=", 32.0, 128.0,
			    256.0, 1);
	    else
		Addimg(((JavaPhotoLab) this).ip.DeCenter
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			((JavaPhotoLab) this).value1,
			((JavaPhotoLab) this).value2));
	    break;
	case 400:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "PSF Size:", 3.0, 7.0, 51.0, 2, "", 0.0, 0.5,
			    2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.PSF((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    (((JavaPhotoLab) this)
						     .value1)));
	    break;
	case 401:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "k Factor:", 0.1, 0.5, 2.0, 0, "", 0.0, 0.5,
			    2.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.EdgeDetect
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			2, ((JavaPhotoLab) this).value1));
	    break;
	case 402:
	    Addimg(((JavaPhotoLab) this).ip.LowPassLinear(((JavaPhotoLab) this)
							  .img
							  [(((JavaPhotoLab)
							     this)
							    .currentimage)]));
	    break;
	case 403:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Window:", 3.0, 3.0, 7.0, 2, "", 0.0, 0.5, 2.0,
			    0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Median((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 404:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Window:", 3.0, 3.0, 7.0, 2, "", 0.0, 0.5, 2.0,
			    0);
	    else
		Addimg(((JavaPhotoLab) this).ip.Kuwahara
		       ((((JavaPhotoLab) this).img
			 [((JavaPhotoLab) this).currentimage]),
			((JavaPhotoLab) this).value1));
	    break;
	case 405:
	    Addimg(((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						   [(((JavaPhotoLab) this)
						     .currentimage)]),
						  1));
	    break;
	case 406:
	    Addimg(((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						   [(((JavaPhotoLab) this)
						     .currentimage)]),
						  2));
	    break;
	case 407:
	    Addimg(((JavaPhotoLab) this).ip.Morph
		   (((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						    [(((JavaPhotoLab) this)
						      .currentimage)]),
						   2),
		    1));
	    break;
	case 408:
	    Addimg(((JavaPhotoLab) this).ip.Morph
		   (((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						    [(((JavaPhotoLab) this)
						      .currentimage)]),
						   1),
		    2));
	    break;
	case 409:
	    Addimg(((JavaPhotoLab) this).ip.Morph
		   ((((JavaPhotoLab) this).ip.Morph
		     ((((JavaPhotoLab) this).ip.Morph
		       (((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       2),
			1)),
		      1)),
		    2));
	    break;
	case 500:
	    Addimg(((JavaPhotoLab) this).ip.EdgeDetect((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       6,
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 501:
	    Addimg(((JavaPhotoLab) this).ip.EdgeDetect((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       1,
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 502:
	    Addimg(((JavaPhotoLab) this).ip.EdgeDetect((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       4,
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 503:
	    Addimg(((JavaPhotoLab) this).ip.EdgeDetect((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       3,
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 504:
	    Addimg(((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						   [(((JavaPhotoLab) this)
						     .currentimage)]),
						  3));
	    break;
	case 505:
	    Addimg(((JavaPhotoLab) this).ip.Morph((((JavaPhotoLab) this).img
						   [(((JavaPhotoLab) this)
						     .currentimage)]),
						  4));
	    break;
	case 506:
	    Addimg(((JavaPhotoLab) this).ip.Kirsh(((JavaPhotoLab) this).img
						  [(((JavaPhotoLab) this)
						    .currentimage)]));
	    break;
	case 600:
	    if (((JavaPhotoLab) this).ip.isFFT(((JavaPhotoLab) this).w,
					       ((JavaPhotoLab) this).h)) {
		((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
		Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    1, 0, true, ""));
	    } else
		this.showStatus("Image dimensions must be power of two!");
	    break;
	case 601:
	    ((ImageProcessing) ((JavaPhotoLab) this).ip).dataset = 0;
	    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this).img
						 [(((JavaPhotoLab) this)
						   .currentimage)]),
						-1, 0, true, ""));
	    break;
	case 602:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues
			(1, "Radius:", 5.0, 20.0,
			 (double) (int) (Math.sqrt((double) (2
							     * ((JavaPhotoLab)
								this).w
							     * ((JavaPhotoLab)
								this).w))
					 / 2.0),
			 1, "", 0.0, 0.5, 2.0, 1);
		else
		    Addimg(((JavaPhotoLab) this).ip.LowPass
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1));
	    }
	    break;
	case 603:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues
			(1, "Radius:", 5.0, 20.0,
			 (double) (int) (Math.sqrt((double) (2
							     * ((JavaPhotoLab)
								this).w
							     * ((JavaPhotoLab)
								this).w))
					 / 2.0),
			 1, "", 0.0, 0.5, 2.0, 1);
		else
		    Addimg(((JavaPhotoLab) this).ip.HighPass
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1));
	    }
	    break;
	case 604:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues
			(1, "Radius:", 5.0, 20.0,
			 (double) (int) (Math.sqrt((double) (2
							     * ((JavaPhotoLab)
								this).w
							     * ((JavaPhotoLab)
								this).w))
					 / 2.0),
			 1, "", 0.0, 0.5, 2.0, 1);
		else
		    Addimg(((JavaPhotoLab) this).ip.ButterLow
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1, 1));
	    }
	    break;
	case 605:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues
			(1, "Radius:", 5.0, 20.0,
			 (double) (int) (Math.sqrt((double) (2
							     * ((JavaPhotoLab)
								this).w
							     * ((JavaPhotoLab)
								this).w))
					 / 2.0),
			 1, "", 0.0, 0.5, 2.0, 0);
		else
		    Addimg(((JavaPhotoLab) this).ip.ButterHigh
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1));
	    }
	    break;
	case 606:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues(1, "Deviation:", 2.0, 10.0, 30.0, 0, "", 0.0,
				0.5, 2.0, 0);
		else
		    Addimg(((JavaPhotoLab) this).ip.GaussianBlur
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1));
	    }
	    break;
	case 607:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues(1, "Pixels:", 5.0, 40.0, 100.0, 1, "", 0.0,
				0.5, 2.0, 0);
		else
		    Addimg(((JavaPhotoLab) this).ip.MotionBlur
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1));
	    }
	    break;
	case 608:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues(2, "Deviation:", 2.0, 10.0, 30.0, 0,
				"s/n Ratio:", 1.0, 3.0, 8.0, 0);
		else
		    Addimg(((JavaPhotoLab) this).ip.GaussianWiener
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1,
			    ((JavaPhotoLab) this).value2));
	    }
	    break;
	case 609:
	    if (((JavaPhotoLab) this).fftmake == true) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues(2, "Pixels:", 5.0, 40.0, 100.0, 1,
				"s/n Ratio:", 1.0, 3.0, 8.0, 0);
		else
		    Addimg(((JavaPhotoLab) this).ip.MotionWiener
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1,
			    ((JavaPhotoLab) this).value2));
	    }
	    break;
	case 610:
	    if (((JavaPhotoLab) this).ip.isFFT(((JavaPhotoLab) this).w,
					       ((JavaPhotoLab) this).h)) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues(2, "Iterations:", 1.0, 1.0, 100.0, 1,
				"PSF Size:", 3.0, 15.0, 51.0, 2);
		else
		    Addimg(((JavaPhotoLab) this).ip.IBD
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1,
			    ((JavaPhotoLab) this).value2));
	    } else
		this.showStatus("Image dimensions must be power of two!");
	    break;
	case 611:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(1, "Quality:", 0.0, 50.0, 100.0, 1, "", 0.0, 0.0,
			    100.0, 1);
	    else
		Addimg(((JavaPhotoLab) this).ip.DCT((((JavaPhotoLab) this).img
						     [(((JavaPhotoLab) this)
						       .currentimage)]),
						    (((JavaPhotoLab) this)
						     .value1)));
	    break;
	case 612:
	    if (((JavaPhotoLab) this).mode == 0)
		EnterValues(2, "Iterations:", 1.0, 1.0, 500.0, 1, "Deviation:",
			    2.0, 10.0, 30.0, 0);
	    else
		Addimg(((JavaPhotoLab) this).ip.RL((((JavaPhotoLab) this).img
						    [(((JavaPhotoLab) this)
						      .currentimage)]),
						   (((JavaPhotoLab) this)
						    .value1),
						   (((JavaPhotoLab) this)
						    .value2)));
	    break;
	case 700:
	    if (((JavaPhotoLab) this).ip.isFFT(((JavaPhotoLab) this).w,
					       ((JavaPhotoLab) this).h)) {
		if (((JavaPhotoLab) this).mode == 0)
		    EnterValues
			(1, "Radius:", 5.0, 20.0,
			 (double) (int) (Math.sqrt((double) (2
							     * ((JavaPhotoLab)
								this).w
							     * ((JavaPhotoLab)
								this).w))
					 / 2.0),
			 1, "", 0.0, 0.0, 100.0, 0);
		else {
		    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]),
							1, 0, true, ""));
		    Addimg(((JavaPhotoLab) this).ip.ButterLow
			   ((((JavaPhotoLab) this).img
			     [((JavaPhotoLab) this).currentimage]),
			    ((JavaPhotoLab) this).value1, 0));
		    Addimg(((JavaPhotoLab) this).ip.FFT((((JavaPhotoLab) this)
							 .img
							 [(((JavaPhotoLab)
							    this)
							   .currentimage)]),
							-1, 0, true, ""));
		}
	    } else
		this.showStatus("Image dimensions must be power of two!");
	    break;
	case 701:
	    Addimg(((JavaPhotoLab) this).ip.EdgeDetect((((JavaPhotoLab) this)
							.img
							[(((JavaPhotoLab) this)
							  .currentimage)]),
						       5,
						       (((JavaPhotoLab) this)
							.value1)));
	    break;
	case 702:
	    Addimg(((JavaPhotoLab) this).ip.Cartoon(((JavaPhotoLab) this).img
						    [(((JavaPhotoLab) this)
						      .currentimage)]));
	    break;
	}
    }
    
    public void ChangeURL(String txt) {
	((JavaPhotoLab) this).urltxt = txt;
	Loadimg(((JavaPhotoLab) this).urltxt, true);
    }
    
    public void SelectChoice(int y, String text, boolean line, Color cl) {
	Graphics g = this.getGraphics();
	g.setFont(new Font("Times", 0, 11));
	if (line)
	    g.setColor(Color.lightGray);
	else
	    g.setColor(((JavaPhotoLab) this).cl1);
	g.drawLine(600, y, 745, y);
	g.drawLine(600, y, 600, y + 13);
	if (line)
	    g.setColor(Color.black);
	else
	    g.setColor(cl);
	g.drawString(text, 610, y + 11);
	if (line)
	    g.setColor(Color.black);
	else
	    g.setColor(((JavaPhotoLab) this).cl1);
	g.drawLine(600, y + 15, 745, y + 15);
	g.drawLine(745, y, 745, y + 15);
	if (line)
	    g.setColor(Color.red);
	else
	    g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(603, y + 6, 4, 4);
    }
    
    public void ClearDesktop() {
	((JavaPhotoLab) this).currentimage = -1;
	((JavaPhotoLab) this).nbimage = -1;
	Graphics g = this.getGraphics();
	g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(0, 0, 595, 455);
    }
    
    public void stopprocess() {
	this.showStatus("Error: Non conform Operation");
    }
    
    public void EnterValues(int nb, String txt1, double min1, double val1,
			    double maxval1, int cond1, String txt2,
			    double min2, double val2, double maxval2,
			    int cond2) {
	((JavaPhotoLab) this).nbvalues = nb;
	((JavaPhotoLab) this).value1 = val1;
	((JavaPhotoLab) this).maxvalue1 = maxval1;
	((JavaPhotoLab) this).value2 = val2;
	((JavaPhotoLab) this).maxvalue2 = maxval2;
	((JavaPhotoLab) this).minvalue1 = min1;
	((JavaPhotoLab) this).minvalue2 = min2;
	((JavaPhotoLab) this).condition1 = cond1;
	((JavaPhotoLab) this).condition2 = cond2;
	((JavaPhotoLab) this).txtval1 = txt1;
	((JavaPhotoLab) this).txtval2 = txt2;
	Graphics g = this.getGraphics();
	valuepaint(g);
	((JavaPhotoLab) this).mode = 1;
    }
    
    public void init() {
	((JavaPhotoLab) this).ip
	    = new ImageProcessing(this, 31415926, "java/awt");
	Loadimg(((JavaPhotoLab) this).filename, false);
	for (((JavaPhotoLab) this).i = 0; ((JavaPhotoLab) this).i < 20;
	     ((JavaPhotoLab) this).i++)
	    ((JavaPhotoLab) this).placeimg[((JavaPhotoLab) this).i] = 0;
    }
    
    public void paint(Graphics g) {
	g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(0, 0, 750, 455);
	g.setFont(new Font("Times", 2, 10));
	String s = new String("");
	for (((JavaPhotoLab) this).i = 0; ((JavaPhotoLab) this).i < 45;
	     ((JavaPhotoLab) this).i++)
	    s += new Character((char) ((JavaPhotoLab) this).nom
				      [((JavaPhotoLab) this).i]);
	g.setColor(Color.black);
	g.drawString(s, 10, 440);
	g.setFont(new Font("Times", 0, 11));
	for (((JavaPhotoLab) this).i = 0;
	     ((JavaPhotoLab) this).i <= ((JavaPhotoLab) this).nbimage;
	     ((JavaPhotoLab) this).i++)
	    drawimage(((JavaPhotoLab) this).i);
	drawimage(((JavaPhotoLab) this).currentimage);
	menupaint(g);
    }
    
    public void valuepaint(Graphics g) {
	g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(0, 425, 750, 25);
	g.setFont(new Font("Times", 0, 11));
	if (((JavaPhotoLab) this).nbvalues > 0) {
	    g.setColor(Color.white);
	    g.drawString(((JavaPhotoLab) this).txtval1, 5, 435);
	    g.setColor(Color.black);
	    g.drawRect(60, 425, 203, 11);
	    g.setColor(Color.cyan);
	    g.fillRect(62, 427, (int) ((((JavaPhotoLab) this).value1
					- ((JavaPhotoLab) this).minvalue1)
				       / (((JavaPhotoLab) this).maxvalue1
					  - ((JavaPhotoLab) this).minvalue1)
				       * 200.0), 8);
	    g.drawString("" + ((JavaPhotoLab) this).value1, 300, 435);
	    g.setColor(Color.yellow);
	    g.fillRect(700, 425, 40, 12);
	    g.setColor(Color.black);
	    g.drawString("Enter", 708, 435);
	    g.drawRect(700, 425, 40, 12);
	}
	if (((JavaPhotoLab) this).nbvalues == 2) {
	    g.setColor(Color.white);
	    g.drawString(((JavaPhotoLab) this).txtval2, 405, 435);
	    g.setColor(Color.black);
	    g.drawRect(460, 425, 203, 11);
	    g.setColor(Color.green);
	    g.fillRect(462, 427, (int) ((((JavaPhotoLab) this).value2
					 - ((JavaPhotoLab) this).minvalue2)
					/ (((JavaPhotoLab) this).maxvalue2
					   - ((JavaPhotoLab) this).minvalue2)
					* 200.0), 8);
	    g.drawString("" + ((JavaPhotoLab) this).value2, 675, 435);
	}
    }
    
    public void menupaint(Graphics g) {
	g.setColor(((JavaPhotoLab) this).cl1);
	g.fillRect(600, 0, 150, 455);
	g.setFont(new Font("Times", 0, 11));
	for (((JavaPhotoLab) this).i = 0;
	     ((JavaPhotoLab) this).i < ((JavaPhotoLab) this).categories;
	     ((JavaPhotoLab) this).i++)
	    SelectChoice(5 + ((JavaPhotoLab) this).i * 16,
			 ((JavaPhotoLab) this).categ[((JavaPhotoLab) this).i],
			 false, Color.yellow);
	for (((JavaPhotoLab) this).i = 0;
	     ((JavaPhotoLab) this).i < (((JavaPhotoLab) this).numchoix
					[((JavaPhotoLab) this).currentchoice]);
	     ((JavaPhotoLab) this).i++)
	    SelectChoice(150 + ((JavaPhotoLab) this).i * 16,
			 (((JavaPhotoLab) this).nomsfiltres
			  [((JavaPhotoLab) this).currentchoice]
			  [((JavaPhotoLab) this).i]),
			 false, Color.white);
	g.setColor(Color.white);
	g.drawLine(600, 142, 745, 142);
    }
    
    public boolean handleEvent(Event e) {
	switch (e.id) {
	case 503:
	    if (((JavaPhotoLab) this).mode == 0) {
		Graphics g = this.getGraphics();
		((JavaPhotoLab) this).i = 50;
		if (e.x > 600 && e.x < 745 && e.y > 5
		    && e.y < 2 + ((JavaPhotoLab) this).categories * 18)
		    ((JavaPhotoLab) this).i = (e.y - 5) / 16;
		for (((JavaPhotoLab) this).j = 0;
		     (((JavaPhotoLab) this).j
		      < ((JavaPhotoLab) this).categories);
		     ((JavaPhotoLab) this).j++) {
		    if (((JavaPhotoLab) this).i == ((JavaPhotoLab) this).j)
			SelectChoice(5 + ((JavaPhotoLab) this).j * 16,
				     (((JavaPhotoLab) this).categ
				      [((JavaPhotoLab) this).j]),
				     true, Color.yellow);
		    else
			SelectChoice(5 + ((JavaPhotoLab) this).j * 16,
				     (((JavaPhotoLab) this).categ
				      [((JavaPhotoLab) this).j]),
				     false, Color.yellow);
		}
		((JavaPhotoLab) this).i = 50;
		if (e.x > 600 && e.x < 745 && e.y > 150
		    && e.y < 147 + ((((JavaPhotoLab) this).numchoix
				     [((JavaPhotoLab) this).currentchoice])
				    * 18))
		    ((JavaPhotoLab) this).i = (e.y - 150) / 16;
		for (((JavaPhotoLab) this).j = 0;
		     (((JavaPhotoLab) this).j
		      < (((JavaPhotoLab) this).numchoix
			 [((JavaPhotoLab) this).currentchoice]));
		     ((JavaPhotoLab) this).j++) {
		    if (((JavaPhotoLab) this).i == ((JavaPhotoLab) this).j)
			SelectChoice(150 + ((JavaPhotoLab) this).j * 16,
				     (((JavaPhotoLab) this).nomsfiltres
				      [((JavaPhotoLab) this).currentchoice]
				      [((JavaPhotoLab) this).j]),
				     true, Color.white);
		    else
			SelectChoice(150 + ((JavaPhotoLab) this).j * 16,
				     (((JavaPhotoLab) this).nomsfiltres
				      [((JavaPhotoLab) this).currentchoice]
				      [((JavaPhotoLab) this).j]),
				     false, Color.white);
		}
	    }
	    break;
	case 501: {
	    Graphics g = this.getGraphics();
	    if (((JavaPhotoLab) this).mode == 0) {
		if (e.x > 600 && e.x < 745 && e.y > 5
		    && e.y < 2 + ((JavaPhotoLab) this).categories * 18) {
		    ((JavaPhotoLab) this).i = (e.y - 5) / 16;
		    ((JavaPhotoLab) this).currentchoice
			= ((JavaPhotoLab) this).i;
		    menupaint(g);
		}
		if (e.x > 600 && e.x < 745 && e.y > 150
		    && e.y < 147 + ((((JavaPhotoLab) this).numchoix
				     [((JavaPhotoLab) this).currentchoice])
				    * 18)) {
		    ((JavaPhotoLab) this).i = (e.y - 150) / 16;
		    ((JavaPhotoLab) this).currentmenu
			= ((JavaPhotoLab) this).i;
		    Launch();
		}
		if (e.x > 0 && e.x < 600 && e.y > 10
		    && e.y < 25 + ((JavaPhotoLab) this).nbimage * 15) {
		    for (((JavaPhotoLab) this).i = 0;
			 ((JavaPhotoLab) this).i < 20;
			 ((JavaPhotoLab) this).i++)
			((JavaPhotoLab) this).placeimg[((JavaPhotoLab) this).i]
			    = 0;
		    ((JavaPhotoLab) this).i = (e.y - 10) / 15;
		    ((JavaPhotoLab) this).currentimage
			= ((JavaPhotoLab) this).i;
		    drawimage(((JavaPhotoLab) this).currentimage);
		    if (e.x >= 14 + ((JavaPhotoLab) this).i * 15
			&& e.x < 18 + ((JavaPhotoLab) this).i * 15
			&& e.y >= 19 + ((JavaPhotoLab) this).i * 15
			&& e.y < 23 + ((JavaPhotoLab) this).i * 15) {
			((JavaPhotoLab) this).placeimg[((JavaPhotoLab) this).i]
			    = 1;
			this.repaint();
		    }
		}
	    } else {
		if (e.x > 62 && e.x <= 262 && e.y > 427 && e.y < 435) {
		    ((JavaPhotoLab) this).value1
			= ((double) (e.x - 62)
			   * (((JavaPhotoLab) this).maxvalue1
			      - ((JavaPhotoLab) this).minvalue1)
			   / 200.0) + ((JavaPhotoLab) this).minvalue1;
		    switch (((JavaPhotoLab) this).condition1) {
		    case 0:
			break;
		    case 1:
			((JavaPhotoLab) this).value1
			    = (double) Math.round(((JavaPhotoLab) this)
						  .value1);
			break;
		    case 2:
			if (Math.ceil(((JavaPhotoLab) this).value1) / 2.0
			    == Math.ceil(((JavaPhotoLab) this).value1 / 2.0))
			    ((JavaPhotoLab) this).value1
				= (Math.ceil(((JavaPhotoLab) this).value1)
				   - 1.0);
			else
			    ((JavaPhotoLab) this).value1
				= Math.ceil(((JavaPhotoLab) this).value1);
			break;
		    }
		    valuepaint(g);
		}
		if (e.x > 462 && e.x <= 662 && e.y > 427 && e.y < 435) {
		    ((JavaPhotoLab) this).value2
			= ((double) (e.x - 462)
			   * (((JavaPhotoLab) this).maxvalue2
			      - ((JavaPhotoLab) this).minvalue2)
			   / 200.0) + ((JavaPhotoLab) this).minvalue2;
		    switch (((JavaPhotoLab) this).condition2) {
		    case 0:
			break;
		    case 1:
			((JavaPhotoLab) this).value2
			    = (double) Math.round(((JavaPhotoLab) this)
						  .value2);
			break;
		    case 2:
			if (Math.ceil(((JavaPhotoLab) this).value2) / 2.0
			    == Math.ceil(((JavaPhotoLab) this).value2 / 2.0))
			    ((JavaPhotoLab) this).value2
				= (Math.ceil(((JavaPhotoLab) this).value2)
				   - 1.0);
			else
			    ((JavaPhotoLab) this).value2
				= Math.ceil(((JavaPhotoLab) this).value2);
			break;
		    }
		    valuepaint(g);
		}
		if (e.x > 700 && e.x < 740 && e.y > 425 && e.y < 437) {
		    Launch();
		    ((JavaPhotoLab) this).mode = 0;
		    valueerase(g);
		}
	    }
	    break;
	}
	}
	return true;
    }
}
