/* Histogram 
 * 12/08/98
 * A. Brochard and P. Rolland
 * Email: abrochard@ices.fr prolland@free.fr
 */
import java.awt.Color;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Graphics;

class Histogram extends Frame
{
    int i;
    int j;
    int rgb;
    int[] rsomme = new int[300];
    int[] gsomme = new int[300];
    int[] bsomme = new int[300];
    int rmax;
    int gmax;
    int bmax;
    double rmean;
    double gmean;
    double bmean;
    double rvar;
    double gvar;
    double bvar;
    
    public Histogram(int[] pix, int w, int h) {
	this.resize(600, 500);
	this.setBackground(new Color(160, 184, 200));
	for (((Histogram) this).i = 0; ((Histogram) this).i < w;
	     ((Histogram) this).i++) {
	    for (((Histogram) this).j = 0; ((Histogram) this).j < h;
		 ((Histogram) this).j++) {
		((Histogram) this).rgb
		    = pix[((Histogram) this).j * w + ((Histogram) this).i];
		((Histogram) this).rsomme[((((Histogram) this).rgb & 0xff0000)
					   >> 16)]++;
		((Histogram) this).gsomme[((((Histogram) this).rgb & 0xff00)
					   >> 8)]++;
		((Histogram) this).bsomme[((Histogram) this).rgb & 0xff]++;
	    }
	}
	((Histogram) this).rmax = 0;
	((Histogram) this).gmax = 0;
	((Histogram) this).bmax = 0;
	for (((Histogram) this).i = 0; ((Histogram) this).i < 256;
	     ((Histogram) this).i++) {
	    if (((Histogram) this).rsomme[((Histogram) this).i]
		> ((Histogram) this).rmax)
		((Histogram) this).rmax
		    = ((Histogram) this).rsomme[((Histogram) this).i];
	    if (((Histogram) this).gsomme[((Histogram) this).i]
		> ((Histogram) this).gmax)
		((Histogram) this).gmax
		    = ((Histogram) this).gsomme[((Histogram) this).i];
	    if (((Histogram) this).bsomme[((Histogram) this).i]
		> ((Histogram) this).bmax)
		((Histogram) this).bmax
		    = ((Histogram) this).bsomme[((Histogram) this).i];
	}
	((Histogram) this).rmean = 0.0;
	((Histogram) this).gmean = 0.0;
	((Histogram) this).bmean = 0.0;
	for (((Histogram) this).i = 0; ((Histogram) this).i < 256;
	     ((Histogram) this).i++) {
	    ((Histogram) this).rmean
		= (((Histogram) this).rmean
		   + (double) (((Histogram) this).i
			       * (((Histogram) this).rsomme
				  [((Histogram) this).i])));
	    ((Histogram) this).gmean
		= (((Histogram) this).gmean
		   + (double) (((Histogram) this).i
			       * (((Histogram) this).gsomme
				  [((Histogram) this).i])));
	    ((Histogram) this).bmean
		= (((Histogram) this).bmean
		   + (double) (((Histogram) this).i
			       * (((Histogram) this).bsomme
				  [((Histogram) this).i])));
	}
	((Histogram) this).rmean = ((Histogram) this).rmean / (double) (w * h);
	((Histogram) this).gmean = ((Histogram) this).gmean / (double) (w * h);
	((Histogram) this).bmean = ((Histogram) this).bmean / (double) (w * h);
    }
    
    public void init() {
	this.resize(600, 500);
    }
    
    public void paint(Graphics g) {
	this.resize(600, 500);
	for (((Histogram) this).i = 0; ((Histogram) this).i < 256;
	     ((Histogram) this).i++) {
	    g.setColor(Color.black);
	    g.drawLine(((Histogram) this).i + 10, 160,
		       ((Histogram) this).i + 10,
		       (int) (160L
			      - Math.round((double) (150
						     * (((Histogram) this)
							.rsomme
							[((Histogram) this).i])
						     / (((Histogram) this)
							.rmax)))));
	    g.drawLine(((Histogram) this).i + 310, 160,
		       ((Histogram) this).i + 310,
		       (int) (160L
			      - Math.round((double) (150
						     * (((Histogram) this)
							.gsomme
							[((Histogram) this).i])
						     / (((Histogram) this)
							.gmax)))));
	    g.drawLine(((Histogram) this).i + 10, 360,
		       ((Histogram) this).i + 10,
		       (int) (360L
			      - Math.round((double) (150
						     * (((Histogram) this)
							.bsomme
							[((Histogram) this).i])
						     / (((Histogram) this)
							.bmax)))));
	    g.drawLine
		(((Histogram) this).i + 310, 360, ((Histogram) this).i + 310,
		 (int) (360L
			- Math.round((double) (((150
						 * (((Histogram) this).rsomme
						    [((Histogram) this).i])
						 / ((Histogram) this).rmax)
						+ (150
						   * (((Histogram) this).gsomme
						      [((Histogram) this).i])
						   / ((Histogram) this).gmax)
						+ (150
						   * (((Histogram) this).bsomme
						      [((Histogram) this).i])
						   / ((Histogram) this).bmax))
					       / 3))));
	    g.setColor(new Color(((Histogram) this).i, 0, 0));
	    g.drawLine(((Histogram) this).i + 10, 180,
		       ((Histogram) this).i + 10, 165);
	    g.setColor(new Color(0, ((Histogram) this).i, 0));
	    g.drawLine(((Histogram) this).i + 310, 180,
		       ((Histogram) this).i + 310, 165);
	    g.setColor(new Color(0, 0, ((Histogram) this).i));
	    g.drawLine(((Histogram) this).i + 10, 380,
		       ((Histogram) this).i + 10, 365);
	    g.setColor(new Color(((Histogram) this).i, ((Histogram) this).i,
				 ((Histogram) this).i));
	    g.drawLine(((Histogram) this).i + 310, 380,
		       ((Histogram) this).i + 310, 365);
	}
	g.setColor(Color.black);
	g.drawString("Red - Mean: " + ((Histogram) this).rmean, 20, 195);
	g.drawString("Green - Mean: " + ((Histogram) this).gmean, 320, 195);
	g.drawString("Blue - Mean: " + ((Histogram) this).bmean, 20, 395);
	g.drawString(("Luminosity - Mean: "
		      + (((Histogram) this).rmean + ((Histogram) this).gmean
			 + ((Histogram) this).bmean) / 3.0),
		     320, 395);
    }
    
    public boolean handleEvent(Event e) {
	if (e.id == 501)
	    this.dispose();
	return true;
    }
}
